/// <reference types="@types/qs" />
import type { AxiosInstance, Method, AxiosRequestConfig } from 'axios';
import type { Errors } from '..';
import qs, { IParseOptions } from 'qs';
declare class BaseService {
    errors: Errors;
    parameters: Record<string, any>;
    endpoint: string;
    static $http: AxiosInstance;
    static $errorProperty: string;
    static $parsedQs: IParseOptions;
    constructor(endpoint: string, parameters: Record<string, any>);
    get $http(): AxiosInstance;
    get $errorProperty(): string;
    get $parsedQs(): qs.IParseOptions;
    all<T>(): Promise<T>;
    find<T>(id: number | string): Promise<T>;
    post<T>(payload: any): Promise<T>;
    post<T>(payload: any, config?: AxiosRequestConfig): Promise<T>;
    store<T>(payload: any): Promise<T>;
    store<T>(payload: any, config?: AxiosRequestConfig): Promise<T>;
    put<T>(payload: any): Promise<T>;
    put<T>(id: string | number, payload: any): Promise<T>;
    put<T>(payload: any, config?: AxiosRequestConfig): Promise<T>;
    put<T>(id: string | number, payload: any, config?: AxiosRequestConfig): Promise<T>;
    patch<T>(payload: any): Promise<T>;
    patch<T>(id: string | number, payload: any): Promise<T>;
    patch<T>(payload: any, config?: AxiosRequestConfig): Promise<T>;
    patch<T>(id: string | number, payload: any, config?: AxiosRequestConfig): Promise<T>;
    update<T>(id: string | number, payload: any): Promise<T>;
    delete<T>(id: string | number): Promise<T>;
    remove<T>(id: string | number): Promise<T>;
    submit<T = any>(requestType: Method): Promise<T>;
    submit<T = any>(requestType: Method, parameter?: string | number): Promise<T>;
    submit<T = any>(requestType: Method, parameter?: string | number, form?: T): Promise<T>;
    submit<T = any>(requestType: Method, parameter?: string | number, form?: T, config?: AxiosRequestConfig): Promise<T>;
    private __getParameterString;
    private static __validateRequestType;
    setParameters(parameters: Record<string, any>): this;
    setParameter(parameter: string): this;
    setParameter(parameter: string, value?: any): this;
    removeParameters(): this;
    removeParameters(parameters: any[]): this;
    removeParameter(parameter: string): this;
    onFail(errors: Record<string, any>): void;
    beforeSubmit(): void;
    onSuccess(): void;
}
export default BaseService;
